<?php
/**
 * OrderReadonlyProperties
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\OmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * OMS
 *
 * Управление заказами
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\OmsClient\Dto;

use \ArrayAccess;
use \Ensi\OmsClient\ObjectSerializer;

/**
 * OrderReadonlyProperties Class Doc Comment
 *
 * @category Class
 * @package  Ensi\OmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class OrderReadonlyProperties implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'OrderReadonlyProperties';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'number' => 'string',
        'customer_id' => 'int',
        'customer_email' => 'string',
        'cost' => 'int',
        'price' => 'int',
        'spent_bonus' => 'int',
        'added_bonus' => 'int',
        'promo_code' => 'string',
        'status_at' => '\DateTime',
        'source' => 'int',
        'payment_status' => 'int',
        'payment_status_at' => '\DateTime',
        'payed_at' => '\DateTime',
        'payment_expires_at' => '\DateTime',
        'payment_method' => 'int',
        'payment_system' => 'int',
        'payment_link' => 'string',
        'payment_external_id' => 'string',
        'is_problem_at' => '\DateTime',
        'is_expired' => 'bool',
        'is_expired_at' => '\DateTime',
        'is_return' => 'bool',
        'is_return_at' => '\DateTime',
        'is_partial_return' => 'bool',
        'is_partial_return_at' => '\DateTime',
        'created_at' => '\DateTime',
        'updated_at' => '\DateTime'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'number' => null,
        'customer_id' => null,
        'customer_email' => null,
        'cost' => null,
        'price' => null,
        'spent_bonus' => null,
        'added_bonus' => null,
        'promo_code' => null,
        'status_at' => 'date-time',
        'source' => null,
        'payment_status' => null,
        'payment_status_at' => 'date-time',
        'payed_at' => 'date-time',
        'payment_expires_at' => 'date-time',
        'payment_method' => null,
        'payment_system' => null,
        'payment_link' => null,
        'payment_external_id' => null,
        'is_problem_at' => 'date-time',
        'is_expired' => null,
        'is_expired_at' => 'date-time',
        'is_return' => null,
        'is_return_at' => 'date-time',
        'is_partial_return' => null,
        'is_partial_return_at' => 'date-time',
        'created_at' => 'date-time',
        'updated_at' => 'date-time'
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'number' => false,
        'customer_id' => false,
        'customer_email' => false,
        'cost' => false,
        'price' => false,
        'spent_bonus' => false,
        'added_bonus' => false,
        'promo_code' => true,
        'status_at' => false,
        'source' => false,
        'payment_status' => false,
        'payment_status_at' => false,
        'payed_at' => true,
        'payment_expires_at' => true,
        'payment_method' => false,
        'payment_system' => false,
        'payment_link' => true,
        'payment_external_id' => true,
        'is_problem_at' => true,
        'is_expired' => false,
        'is_expired_at' => true,
        'is_return' => false,
        'is_return_at' => true,
        'is_partial_return' => false,
        'is_partial_return_at' => true,
        'created_at' => false,
        'updated_at' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'number' => 'number',
        'customer_id' => 'customer_id',
        'customer_email' => 'customer_email',
        'cost' => 'cost',
        'price' => 'price',
        'spent_bonus' => 'spent_bonus',
        'added_bonus' => 'added_bonus',
        'promo_code' => 'promo_code',
        'status_at' => 'status_at',
        'source' => 'source',
        'payment_status' => 'payment_status',
        'payment_status_at' => 'payment_status_at',
        'payed_at' => 'payed_at',
        'payment_expires_at' => 'payment_expires_at',
        'payment_method' => 'payment_method',
        'payment_system' => 'payment_system',
        'payment_link' => 'payment_link',
        'payment_external_id' => 'payment_external_id',
        'is_problem_at' => 'is_problem_at',
        'is_expired' => 'is_expired',
        'is_expired_at' => 'is_expired_at',
        'is_return' => 'is_return',
        'is_return_at' => 'is_return_at',
        'is_partial_return' => 'is_partial_return',
        'is_partial_return_at' => 'is_partial_return_at',
        'created_at' => 'created_at',
        'updated_at' => 'updated_at'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'number' => 'setNumber',
        'customer_id' => 'setCustomerId',
        'customer_email' => 'setCustomerEmail',
        'cost' => 'setCost',
        'price' => 'setPrice',
        'spent_bonus' => 'setSpentBonus',
        'added_bonus' => 'setAddedBonus',
        'promo_code' => 'setPromoCode',
        'status_at' => 'setStatusAt',
        'source' => 'setSource',
        'payment_status' => 'setPaymentStatus',
        'payment_status_at' => 'setPaymentStatusAt',
        'payed_at' => 'setPayedAt',
        'payment_expires_at' => 'setPaymentExpiresAt',
        'payment_method' => 'setPaymentMethod',
        'payment_system' => 'setPaymentSystem',
        'payment_link' => 'setPaymentLink',
        'payment_external_id' => 'setPaymentExternalId',
        'is_problem_at' => 'setIsProblemAt',
        'is_expired' => 'setIsExpired',
        'is_expired_at' => 'setIsExpiredAt',
        'is_return' => 'setIsReturn',
        'is_return_at' => 'setIsReturnAt',
        'is_partial_return' => 'setIsPartialReturn',
        'is_partial_return_at' => 'setIsPartialReturnAt',
        'created_at' => 'setCreatedAt',
        'updated_at' => 'setUpdatedAt'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'number' => 'getNumber',
        'customer_id' => 'getCustomerId',
        'customer_email' => 'getCustomerEmail',
        'cost' => 'getCost',
        'price' => 'getPrice',
        'spent_bonus' => 'getSpentBonus',
        'added_bonus' => 'getAddedBonus',
        'promo_code' => 'getPromoCode',
        'status_at' => 'getStatusAt',
        'source' => 'getSource',
        'payment_status' => 'getPaymentStatus',
        'payment_status_at' => 'getPaymentStatusAt',
        'payed_at' => 'getPayedAt',
        'payment_expires_at' => 'getPaymentExpiresAt',
        'payment_method' => 'getPaymentMethod',
        'payment_system' => 'getPaymentSystem',
        'payment_link' => 'getPaymentLink',
        'payment_external_id' => 'getPaymentExternalId',
        'is_problem_at' => 'getIsProblemAt',
        'is_expired' => 'getIsExpired',
        'is_expired_at' => 'getIsExpiredAt',
        'is_return' => 'getIsReturn',
        'is_return_at' => 'getIsReturnAt',
        'is_partial_return' => 'getIsPartialReturn',
        'is_partial_return_at' => 'getIsPartialReturnAt',
        'created_at' => 'getCreatedAt',
        'updated_at' => 'getUpdatedAt'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('number', $data, null);
        $this->setIfExists('customer_id', $data, null);
        $this->setIfExists('customer_email', $data, null);
        $this->setIfExists('cost', $data, null);
        $this->setIfExists('price', $data, null);
        $this->setIfExists('spent_bonus', $data, null);
        $this->setIfExists('added_bonus', $data, null);
        $this->setIfExists('promo_code', $data, null);
        $this->setIfExists('status_at', $data, null);
        $this->setIfExists('source', $data, null);
        $this->setIfExists('payment_status', $data, null);
        $this->setIfExists('payment_status_at', $data, null);
        $this->setIfExists('payed_at', $data, null);
        $this->setIfExists('payment_expires_at', $data, null);
        $this->setIfExists('payment_method', $data, null);
        $this->setIfExists('payment_system', $data, null);
        $this->setIfExists('payment_link', $data, null);
        $this->setIfExists('payment_external_id', $data, null);
        $this->setIfExists('is_problem_at', $data, null);
        $this->setIfExists('is_expired', $data, null);
        $this->setIfExists('is_expired_at', $data, null);
        $this->setIfExists('is_return', $data, null);
        $this->setIfExists('is_return_at', $data, null);
        $this->setIfExists('is_partial_return', $data, null);
        $this->setIfExists('is_partial_return_at', $data, null);
        $this->setIfExists('created_at', $data, null);
        $this->setIfExists('updated_at', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id ID заказа
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets number
     *
     * @return string|null
     */
    public function getNumber()
    {
        return $this->container['number'];
    }

    /**
     * Sets number
     *
     * @param string|null $number номер заказа
     *
     * @return $this
     */
    public function setNumber($number)
    {


        /*if (is_null($number)) {
            throw new \InvalidArgumentException('non-nullable number cannot be null');
        }*/
        $this->container['number'] = $number;

        return $this;
    }

    /**
     * Gets customer_id
     *
     * @return int|null
     */
    public function getCustomerId()
    {
        return $this->container['customer_id'];
    }

    /**
     * Sets customer_id
     *
     * @param int|null $customer_id id покупателя
     *
     * @return $this
     */
    public function setCustomerId($customer_id)
    {


        /*if (is_null($customer_id)) {
            throw new \InvalidArgumentException('non-nullable customer_id cannot be null');
        }*/
        $this->container['customer_id'] = $customer_id;

        return $this;
    }

    /**
     * Gets customer_email
     *
     * @return string|null
     */
    public function getCustomerEmail()
    {
        return $this->container['customer_email'];
    }

    /**
     * Sets customer_email
     *
     * @param string|null $customer_email почта покупателя
     *
     * @return $this
     */
    public function setCustomerEmail($customer_email)
    {


        /*if (is_null($customer_email)) {
            throw new \InvalidArgumentException('non-nullable customer_email cannot be null');
        }*/
        $this->container['customer_email'] = $customer_email;

        return $this;
    }

    /**
     * Gets cost
     *
     * @return int|null
     */
    public function getCost()
    {
        return $this->container['cost'];
    }

    /**
     * Sets cost
     *
     * @param int|null $cost стоимость (без учета скидки) (рассчитывается автоматически) в коп.
     *
     * @return $this
     */
    public function setCost($cost)
    {


        /*if (is_null($cost)) {
            throw new \InvalidArgumentException('non-nullable cost cannot be null');
        }*/
        $this->container['cost'] = $cost;

        return $this;
    }

    /**
     * Gets price
     *
     * @return int|null
     */
    public function getPrice()
    {
        return $this->container['price'];
    }

    /**
     * Sets price
     *
     * @param int|null $price стоимость (с учетом скидок) (рассчитывается автоматически) в коп.
     *
     * @return $this
     */
    public function setPrice($price)
    {


        /*if (is_null($price)) {
            throw new \InvalidArgumentException('non-nullable price cannot be null');
        }*/
        $this->container['price'] = $price;

        return $this;
    }

    /**
     * Gets spent_bonus
     *
     * @return int|null
     */
    public function getSpentBonus()
    {
        return $this->container['spent_bonus'];
    }

    /**
     * Sets spent_bonus
     *
     * @param int|null $spent_bonus списано бонусов
     *
     * @return $this
     */
    public function setSpentBonus($spent_bonus)
    {


        /*if (is_null($spent_bonus)) {
            throw new \InvalidArgumentException('non-nullable spent_bonus cannot be null');
        }*/
        $this->container['spent_bonus'] = $spent_bonus;

        return $this;
    }

    /**
     * Gets added_bonus
     *
     * @return int|null
     */
    public function getAddedBonus()
    {
        return $this->container['added_bonus'];
    }

    /**
     * Sets added_bonus
     *
     * @param int|null $added_bonus начислено бонусов
     *
     * @return $this
     */
    public function setAddedBonus($added_bonus)
    {


        /*if (is_null($added_bonus)) {
            throw new \InvalidArgumentException('non-nullable added_bonus cannot be null');
        }*/
        $this->container['added_bonus'] = $added_bonus;

        return $this;
    }

    /**
     * Gets promo_code
     *
     * @return string|null
     */
    public function getPromoCode()
    {
        return $this->container['promo_code'];
    }

    /**
     * Sets promo_code
     *
     * @param string|null $promo_code Использованный промокод
     *
     * @return $this
     */
    public function setPromoCode($promo_code)
    {

        if (is_null($promo_code)) {
            array_push($this->openAPINullablesSetToNull, 'promo_code');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('promo_code', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['promo_code'] = $promo_code;

        return $this;
    }

    /**
     * Gets status_at
     *
     * @return \DateTime|null
     */
    public function getStatusAt()
    {
        return $this->container['status_at'];
    }

    /**
     * Sets status_at
     *
     * @param \DateTime|null $status_at дата установки статуса заказа
     *
     * @return $this
     */
    public function setStatusAt($status_at)
    {


        /*if (is_null($status_at)) {
            throw new \InvalidArgumentException('non-nullable status_at cannot be null');
        }*/
        $this->container['status_at'] = $status_at;

        return $this;
    }

    /**
     * Gets source
     *
     * @return int|null
     */
    public function getSource()
    {
        return $this->container['source'];
    }

    /**
     * Sets source
     *
     * @param int|null $source источник заказа из OrderSourceEnum
     *
     * @return $this
     */
    public function setSource($source)
    {


        /*if (is_null($source)) {
            throw new \InvalidArgumentException('non-nullable source cannot be null');
        }*/
        $this->container['source'] = $source;

        return $this;
    }

    /**
     * Gets payment_status
     *
     * @return int|null
     */
    public function getPaymentStatus()
    {
        return $this->container['payment_status'];
    }

    /**
     * Sets payment_status
     *
     * @param int|null $payment_status статус оплаты из PaymentStatusEnum
     *
     * @return $this
     */
    public function setPaymentStatus($payment_status)
    {


        /*if (is_null($payment_status)) {
            throw new \InvalidArgumentException('non-nullable payment_status cannot be null');
        }*/
        $this->container['payment_status'] = $payment_status;

        return $this;
    }

    /**
     * Gets payment_status_at
     *
     * @return \DateTime|null
     */
    public function getPaymentStatusAt()
    {
        return $this->container['payment_status_at'];
    }

    /**
     * Sets payment_status_at
     *
     * @param \DateTime|null $payment_status_at дата установки статуса оплаты
     *
     * @return $this
     */
    public function setPaymentStatusAt($payment_status_at)
    {


        /*if (is_null($payment_status_at)) {
            throw new \InvalidArgumentException('non-nullable payment_status_at cannot be null');
        }*/
        $this->container['payment_status_at'] = $payment_status_at;

        return $this;
    }

    /**
     * Gets payed_at
     *
     * @return \DateTime|null
     */
    public function getPayedAt()
    {
        return $this->container['payed_at'];
    }

    /**
     * Sets payed_at
     *
     * @param \DateTime|null $payed_at Дата оплаты
     *
     * @return $this
     */
    public function setPayedAt($payed_at)
    {

        if (is_null($payed_at)) {
            array_push($this->openAPINullablesSetToNull, 'payed_at');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('payed_at', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['payed_at'] = $payed_at;

        return $this;
    }

    /**
     * Gets payment_expires_at
     *
     * @return \DateTime|null
     */
    public function getPaymentExpiresAt()
    {
        return $this->container['payment_expires_at'];
    }

    /**
     * Sets payment_expires_at
     *
     * @param \DateTime|null $payment_expires_at Дата, до которой нужно провести оплату
     *
     * @return $this
     */
    public function setPaymentExpiresAt($payment_expires_at)
    {

        if (is_null($payment_expires_at)) {
            array_push($this->openAPINullablesSetToNull, 'payment_expires_at');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('payment_expires_at', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['payment_expires_at'] = $payment_expires_at;

        return $this;
    }

    /**
     * Gets payment_method
     *
     * @return int|null
     */
    public function getPaymentMethod()
    {
        return $this->container['payment_method'];
    }

    /**
     * Sets payment_method
     *
     * @param int|null $payment_method метод оплаты из PaymentMethodEnum
     *
     * @return $this
     */
    public function setPaymentMethod($payment_method)
    {


        /*if (is_null($payment_method)) {
            throw new \InvalidArgumentException('non-nullable payment_method cannot be null');
        }*/
        $this->container['payment_method'] = $payment_method;

        return $this;
    }

    /**
     * Gets payment_system
     *
     * @return int|null
     */
    public function getPaymentSystem()
    {
        return $this->container['payment_system'];
    }

    /**
     * Sets payment_system
     *
     * @param int|null $payment_system система оплаты из PaymentSystemEnum
     *
     * @return $this
     */
    public function setPaymentSystem($payment_system)
    {


        /*if (is_null($payment_system)) {
            throw new \InvalidArgumentException('non-nullable payment_system cannot be null');
        }*/
        $this->container['payment_system'] = $payment_system;

        return $this;
    }

    /**
     * Gets payment_link
     *
     * @return string|null
     */
    public function getPaymentLink()
    {
        return $this->container['payment_link'];
    }

    /**
     * Sets payment_link
     *
     * @param string|null $payment_link Ссылка для оплаты во внещней системе
     *
     * @return $this
     */
    public function setPaymentLink($payment_link)
    {

        if (is_null($payment_link)) {
            array_push($this->openAPINullablesSetToNull, 'payment_link');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('payment_link', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['payment_link'] = $payment_link;

        return $this;
    }

    /**
     * Gets payment_external_id
     *
     * @return string|null
     */
    public function getPaymentExternalId()
    {
        return $this->container['payment_external_id'];
    }

    /**
     * Sets payment_external_id
     *
     * @param string|null $payment_external_id ID оплаты во внешней системе
     *
     * @return $this
     */
    public function setPaymentExternalId($payment_external_id)
    {

        if (is_null($payment_external_id)) {
            array_push($this->openAPINullablesSetToNull, 'payment_external_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('payment_external_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['payment_external_id'] = $payment_external_id;

        return $this;
    }

    /**
     * Gets is_problem_at
     *
     * @return \DateTime|null
     */
    public function getIsProblemAt()
    {
        return $this->container['is_problem_at'];
    }

    /**
     * Sets is_problem_at
     *
     * @param \DateTime|null $is_problem_at дата установки флага проблемного заказа
     *
     * @return $this
     */
    public function setIsProblemAt($is_problem_at)
    {

        if (is_null($is_problem_at)) {
            array_push($this->openAPINullablesSetToNull, 'is_problem_at');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('is_problem_at', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['is_problem_at'] = $is_problem_at;

        return $this;
    }

    /**
     * Gets is_expired
     *
     * @return bool|null
     */
    public function getIsExpired()
    {
        return $this->container['is_expired'];
    }

    /**
     * Sets is_expired
     *
     * @param bool|null $is_expired флаг, что заказ просроченный
     *
     * @return $this
     */
    public function setIsExpired($is_expired)
    {


        /*if (is_null($is_expired)) {
            throw new \InvalidArgumentException('non-nullable is_expired cannot be null');
        }*/
        $this->container['is_expired'] = $is_expired;

        return $this;
    }

    /**
     * Gets is_expired_at
     *
     * @return \DateTime|null
     */
    public function getIsExpiredAt()
    {
        return $this->container['is_expired_at'];
    }

    /**
     * Sets is_expired_at
     *
     * @param \DateTime|null $is_expired_at дата установки флага просроченного заказа
     *
     * @return $this
     */
    public function setIsExpiredAt($is_expired_at)
    {

        if (is_null($is_expired_at)) {
            array_push($this->openAPINullablesSetToNull, 'is_expired_at');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('is_expired_at', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['is_expired_at'] = $is_expired_at;

        return $this;
    }

    /**
     * Gets is_return
     *
     * @return bool|null
     */
    public function getIsReturn()
    {
        return $this->container['is_return'];
    }

    /**
     * Sets is_return
     *
     * @param bool|null $is_return флаг, что заказ возвращен
     *
     * @return $this
     */
    public function setIsReturn($is_return)
    {


        /*if (is_null($is_return)) {
            throw new \InvalidArgumentException('non-nullable is_return cannot be null');
        }*/
        $this->container['is_return'] = $is_return;

        return $this;
    }

    /**
     * Gets is_return_at
     *
     * @return \DateTime|null
     */
    public function getIsReturnAt()
    {
        return $this->container['is_return_at'];
    }

    /**
     * Sets is_return_at
     *
     * @param \DateTime|null $is_return_at дата установки флага возвращенного заказа
     *
     * @return $this
     */
    public function setIsReturnAt($is_return_at)
    {

        if (is_null($is_return_at)) {
            array_push($this->openAPINullablesSetToNull, 'is_return_at');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('is_return_at', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['is_return_at'] = $is_return_at;

        return $this;
    }

    /**
     * Gets is_partial_return
     *
     * @return bool|null
     */
    public function getIsPartialReturn()
    {
        return $this->container['is_partial_return'];
    }

    /**
     * Sets is_partial_return
     *
     * @param bool|null $is_partial_return флаг, что заказ частично возвращен
     *
     * @return $this
     */
    public function setIsPartialReturn($is_partial_return)
    {


        /*if (is_null($is_partial_return)) {
            throw new \InvalidArgumentException('non-nullable is_partial_return cannot be null');
        }*/
        $this->container['is_partial_return'] = $is_partial_return;

        return $this;
    }

    /**
     * Gets is_partial_return_at
     *
     * @return \DateTime|null
     */
    public function getIsPartialReturnAt()
    {
        return $this->container['is_partial_return_at'];
    }

    /**
     * Sets is_partial_return_at
     *
     * @param \DateTime|null $is_partial_return_at дата установки флага частично возвращенного заказа
     *
     * @return $this
     */
    public function setIsPartialReturnAt($is_partial_return_at)
    {

        if (is_null($is_partial_return_at)) {
            array_push($this->openAPINullablesSetToNull, 'is_partial_return_at');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('is_partial_return_at', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['is_partial_return_at'] = $is_partial_return_at;

        return $this;
    }

    /**
     * Gets created_at
     *
     * @return \DateTime|null
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     *
     * @param \DateTime|null $created_at дата создания заказа
     *
     * @return $this
     */
    public function setCreatedAt($created_at)
    {


        /*if (is_null($created_at)) {
            throw new \InvalidArgumentException('non-nullable created_at cannot be null');
        }*/
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets updated_at
     *
     * @return \DateTime|null
     */
    public function getUpdatedAt()
    {
        return $this->container['updated_at'];
    }

    /**
     * Sets updated_at
     *
     * @param \DateTime|null $updated_at дата обновления заказа
     *
     * @return $this
     */
    public function setUpdatedAt($updated_at)
    {


        /*if (is_null($updated_at)) {
            throw new \InvalidArgumentException('non-nullable updated_at cannot be null');
        }*/
        $this->container['updated_at'] = $updated_at;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


